
#include <iostream>
#include <fstream>
#include "twister.h"
#include "tsccd-ea.h"
#include "log.h"

using namespace std;

MTRand mt;


int main ( int argc, char ** argv )
{
	TSCCD_EA::Params p;
	p.tsccd_k = 4;
	p.tsccd_v = 12;
	
	p.maxinitlen = 10;
	
	p.mutate.mutaterate = 0.5;
	
	p.popsize = 200;
	p.offspring = 10;
	
	TSCCD_EA sim;
	sim.initialize( p );
	
	Log log( "log.csv" );
	for( int i = 1; i <= 500; i++ )
	{
		for( int j = 1; j <= 5; j++ )
			sim.breed();
		sim.select();
		
		cout << i << " : " << sim.getStats().avg_fit << endl;
		log.capture( sim.getStats() );
	}
	
	return 0;
}
