#ifndef TSCCDBLOCK_H_
#define TSCCDBLOCK_H_

#include <iostream>
#include <vector>
#include <string>
#include "tsccd-move.h"

using std::string;

class TSCCD_Block
{
	public:
		TSCCD_Block ( const unsigned int k ); // create a block [0..k-1]
		TSCCD_Block ( const std::vector<unsigned int> symbols ); // create a block from the given values
		TSCCD_Block ( const TSCCD_Block & src );
		~TSCCD_Block ();
		const TSCCD_Block & operator= ( const TSCCD_Block & rhs );
		const unsigned int & operator[] ( const unsigned int pos ) const;
		const unsigned int getK () const;
		
		void applyMove ( const TSCCD_Move & move );
			// change this block according to 'move'
		
		float similarity ( const TSCCD_Block & other ) const;
			// return ratio of symbols that match other, [0.0,1.0]
		
		void print () const;
		
	private:
		unsigned int m_k;
		unsigned int * m_syms;
};


#endif /*TSCCDBLOCK_H_*/
