#ifndef TSCCD_MOVE_H_
#define TSCCD_MOVE_H_

// a Move is used to add a block to the puzzle. the last (current) block is copied,
//  replacing the symbol at index 'pos' with 'symbol'
// pos is [0,k-1], symbol is [0,v-1]

class TSCCD_Move
{
	public:
		TSCCD_Move ( const unsigned int pos, const unsigned int symbol )
			: m_pos( pos ), m_symbol( symbol ) {}
		
		inline const unsigned int & pos () const { return m_pos; }
		inline const unsigned int & symbol () const { return m_symbol; }
		
	private:
		unsigned int m_pos;
		unsigned int m_symbol;
};


#endif /*TSCCD_MOVE_H_*/
