
class TSCCD_SymMap;

#ifndef TSCCDSYMMAP_H_
#define TSCCDSYMMAP_H_

// this class captures a mapping of integers onto integers
// especially for use with TSCCDs
// WARN: this class is NOT yet idiot-proof


#include "tsccd-puzzle.h"
#include "twister.h"

extern MTRand mt;

class TSCCD_SymMap
{
	public:
		TSCCD_SymMap ( const unsigned int v );
		~TSCCD_SymMap ();
		
		void captureMap ( const TSCCD_Block & fromblock,
											const TSCCD_Block & toblock );
			// set up this map such that it maps fromblock to toblock
		
		void setMap ( const std::vector< unsigned int > & tomap );
			// tomap must be size v, having exactly one each of the values [0..v-1]
			// sets up this map such that [0..v-1] map to the contents of tomap, in order
		
		void setSingle ( const unsigned int fromsym, const unsigned int tosym );
			// update to map fromsym to tosym
			// other mappings may change to maintain 1-1 mapping
		
		void setNormal ();
			// set all values to map to themselves
		
		void setRandom ();
			// set up a random mapping
		
		unsigned int map ( const unsigned int sym ) const;
			// map the given value [0..v-1]
		
		TSCCD_Block mapBlock ( const TSCCD_Block & fromblock ) const;
			// map the entire block
		
		TSCCD_Move mapMove ( const TSCCD_Move & frommove ) const;
			// map the symbol in the given move
		
		PairCover mapCover ( const PairCover & fromcover ) const;
		
		//unsigned int unmap ( const unsigned int sym ) const;
			// unmap ( reverse map ) the given value [0..v-1]
		
		
		void print ();
		
	private:
		const unsigned int m_v;
		unsigned int * m_map, *m_unmap;
		// m_unmap[j] is the index into m_map where j can be found
};

#endif /*TSCCDSYMMAP_H_*/
